#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR "Eylon.A (AuToPrO)"
#define PLUGIN_VERSION "1.00"
#define PREFIX " \x07[Eylonap_Votect]\x01"
#define MENUPREFIX "[Eylonap_Votect]"
#define MOVES 7
#define MAXBUTTONS 11
#define MAX_BUTTONS 25

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <sdkhooks>
#include <smlib>
#include <basecomm>
#include <adminmenu>
#include <clientprefs>

enum
{
	VoteCt_Off, 
	VoteCt_GodRound, 
	VoteCt_Wait, 
	VoteCt_RandomNumber, 
	VoteCt_RandomPlayer, 
	VoteCt_MostJump, 
	VoteCt_FindDeagle, 
	VoteCt_FastWrite, 
	VoteCt_Math, 
	VoteCt_Combo, 
}

Handle airfix = INVALID_HANDLE, randomnumber_client = INVALID_HANDLE, randomnumber_number = INVALID_HANDLE, randomplayer = INVALID_HANDLE, ctalgorithm = INVALID_HANDLE, viptimer[MAXPLAYERS + 1] = INVALID_HANDLE, ctbanconnect = INVALID_HANDLE, findthedeagle = INVALID_HANDLE, fastwrite = INVALID_HANDLE, mathquestion = INVALID_HANDLE, combotimer = INVALID_HANDLE, comboendtime = INVALID_HANDLE;
int RandomNumber = -1, winnum = -1, lastnum = 350, CtChooser = -1, VoteCtType, jumpcount[MAXPLAYERS + 1], spawncounts = 0, realweapon = 0, MathNumber = -1, g_LastButtons[MAXPLAYERS + 1], ComboMoves[MOVES] =  { 0, ... }, PlayerPos[MAXPLAYERS + 1] =  { 0, ... }, Buttons[MAXBUTTONS] =  { IN_ATTACK, IN_ATTACK2, IN_JUMP, IN_DUCK, IN_FORWARD, IN_BACK, IN_USE, IN_MOVELEFT, IN_MOVERIGHT, IN_RELOAD, IN_SCORE };
ConVar votecttime = null, randomnumbertime = null, startmutetime = null, ctsvsguardscount = null, ctanswertime = null, randomplayertime = null, mostjumptime = null, finddeagle = null, fastwritetime = null, mathquestiontime = null, combotime = null, godroundtime = null;
float spawnpos[32][3];
bool boxstatus = false, VoteCt_CellsOpen = false;
char fastwritestring[32], sButtons[][] =  { "Attack", "Attack2", "Jump", "Duck", "Forward", "Back", "Use", "Moveleft", "Moveright", "Reload", "Score" }, /*votectpath[128],*/ VoteCt_Currectmap[32];

public Plugin myinfo = 
{
	name = "Eylonap_Votect", 
	author = PLUGIN_AUTHOR, 
	description = "JailBreak VoteCt", 
	version = PLUGIN_VERSION, 
	url = "https://forums.alliedmods.net/member.php?u=273439"
};

public OnPluginStart()
{
	airfix = FindConVar("sv_airaccelerate");
	
	RegAdminCmd("sm_votect", cmd_votect, ADMFLAG_BAN);
	RegConsoleCmd("sm_ctlist", cmd_ctlist);
	RegConsoleCmd("sm_tlist", cmd_ctlist);
	RegConsoleCmd("sm_kickct", cmd_kickct);
	RegConsoleCmd("sm_vip", cmd_vip);
	RegConsoleCmd("sm_ctchooser", cmd_ctchooser);
	RegConsoleCmd("sm_open", cmd_open);
	RegConsoleCmd("sm_box", cmd_box);
	AddCommandListener(Command_Say, "say");
	AddCommandListener(Command_Say, "say_team");
	AddCommandListener(Command_JoinTeam, "jointeam");
	HookConVarChange(airfix, AirFixCb);
	HookEvent("round_start", Event_RoundStart);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("round_end", Event_RoundEnd);
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_jump", Event_Jump);
	ctbanconnect = RegClientCookie("Banned_From_CT", "Tells if you are restricted from joining the CT team", CookieAccess_Protected);
	VoteCtType = VoteCt_Off;
	randomnumber_number = CreateArray(1);
	randomnumber_client = CreateArray(1);
	randomplayer = CreateArray(1);
	ctalgorithm = CreateArray(1);
	votecttime = CreateConVar("Eylonap_VoteCt_Display_Time", "30.0", "", 0, true, 5.0, true, 60.0);
	randomnumbertime = CreateConVar("Eylonap_Random_Number_Time", "35.0", "", 0, true, 1.0, true, 45.0);
	startmutetime = CreateConVar("Eylonap_Round_Start_Mute_All_Time", "15.0", "", 0, true, 0.0, true, 60.0);
	ctsvsguardscount = CreateConVar("Eylonap_How_many_t`s_for_1_ct`s", "3.0", "", 0, true, 1.0, true, 6.0);
	ctanswertime = CreateConVar("Eylonap_How_many_time_for_ct`s_invite", "15.0", "", 0, true, 5.0, true, 60.0);
	randomplayertime = CreateConVar("Eylonap_Random_Player_Time", "10.0", "", 0, true, 2.0, true, 60.0);
	mostjumptime = CreateConVar("Eylonap_Most_Jump_Time", "30.0", "", 0, true, 10.0, true, 60.0);
	finddeagle = CreateConVar("Eylonap_Find_The_Deagle_Max_Time", "300.0", "", 0, true, 120.0, true, 420.0);
	fastwritetime = CreateConVar("Eylonap_Fast_Write_Max_Time", "300.0", "", 0, true, 120.0, true, 420.0);
	mathquestiontime = CreateConVar("Eylonap_Math_Qustion_Max_Time", "300.0", "", 0, true, 120.0, true, 420.0);
	combotime = CreateConVar("Eylonap_Combo_Max_Time", "300.0", "", 0, true, 120.0, true, 420.0);
	godroundtime = CreateConVar("Eylonap_God_Round_Time", "45", "", 0, true, 120.0, true, 10.0);
	//BuildPath(Path_SM, votectpath, sizeof(votectpath), "configs/eylonap_votect.cfg"); Words game -incoming-
	AutoExecConfig(true, "Eylonap_Votect");
	CreateTimer(60.0, checkctcb, INVALID_HANDLE, TIMER_REPEAT);
}

public void AirFixCb(Handle convar, const char[] oldValue, const char[] newValue)
{
	if (!StrEqual(oldValue, newValue))
	{
		SetConVarInt(airfix, 99999);
	}
}

public Action cmd_open(int client, int args)
{
	if (!IsPlayerAlive(client))
	{
		PrintToChat(client, "%s You need to be alive to use this command.", PREFIX);
		return Plugin_Handled;
	}
	if (GetClientTeam(client) != CS_TEAM_CT && !CheckCommandAccess(client, "sm_admin", ADMFLAG_BAN))
	{
		PrintToChat(client, "%s This command resserved for ct`s.", PREFIX);
		return Plugin_Handled;
	}
	if (VoteCt_CellsOpen)
	{
		PrintToChat(client, "%s The cells already open.", PREFIX);
		return Plugin_Handled;
	}
	bool Success;
	
	static gI_Entity;
	
	gI_Entity = -1;
	
	while ((gI_Entity = Entity_FindByClassName(gI_Entity, "func_door")) != INVALID_ENT_REFERENCE)
	{
		char name[32];
		Entity_GetName(gI_Entity, name, 32);
		
		if (StrContains(name, "cell", false) != -1 || StrContains(name, "cage", false) != -1 || StrContains(name, "prison", false) != -1 || StrContains(name, "open", false) != -1 || StrContains(name, "taim", false) != -1 || StrContains(name, "jaildoor", false) != -1 || StrEqual(name, "c1", false))
		{
			AcceptEntityInput(gI_Entity, "Open");
			
			Success = true;
		}
	}
	
	gI_Entity = -1;
	
	while ((gI_Entity = Entity_FindByClassName(gI_Entity, "func_button")) != INVALID_ENT_REFERENCE)
	{
		char name[32];
		Entity_GetName(gI_Entity, name, 32);
		
		if (StrEqual(VoteCt_Currectmap, "jb_vipinthemix_v1_2", false))
		{
			if (Entity_GetHammerId(gI_Entity) == 40045)
			{
				AcceptEntityInput(gI_Entity, "Use");
				
				Success = true;
			}
		}
		
		if (StrEqual(VoteCt_Currectmap, "ba_jail_dubai", false))
		{
			if (Entity_GetHammerId(gI_Entity) == 4276)
			{
				AcceptEntityInput(gI_Entity, "Use");
				Success = true;
			}
		}
		
		else if (StrContains(name, "cell", false) != -1 || StrContains(name, "cage", false) != -1 || StrContains(name, "prison", false) != -1 || StrContains(name, "open", false) != -1 || StrContains(name, "taim", false) != -1 || StrContains(name, "jaildoor", false) != -1)
		{
			AcceptEntityInput(gI_Entity, "Use");
			
			Success = true;
		}
	}
	
	VoteCt_CellsOpen = Success;
	
	if (Success)
	{
		PrintToChatAll("%s %N open all the cells.", PREFIX, client);
	}
	return Plugin_Handled;
}

public Action cmd_box(int client, int args)
{
	if (!IsPlayerAlive(client))
	{
		PrintToChat(client, "%s You need to be alive to use this command.", PREFIX);
		return Plugin_Handled;
	}
	int alivecount = 0;
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam(i) == CS_TEAM_T)++alivecount;
	if (GetClientTeam(client) != CS_TEAM_CT && !CheckCommandAccess(client, "sm_admin", ADMFLAG_BAN))
	{
		PrintToChat(client, "%s This command resserved for ct`s.", PREFIX);
		return Plugin_Handled;
	}
	if (alivecount < 3)
	{
		PrintToChat(client, "%s You need 3+ alive terrorist`s for start this game.", PREFIX);
		return Plugin_Handled;
	}
	char title[64];
	Menu box = new Menu(boxcb);
	Format(title, sizeof(title), "%s Box Menu \n You have %d alive terrorist`s", MENUPREFIX, alivecount);
	box.SetTitle(title);
	if (!boxstatus)
	{
		box.AddItem("on", "On!");
		box.AddItem("off", "Stop!", ITEMDRAW_DISABLED);
	} else
	{
		if (boxstatus)box.AddItem("on", "Start!", ITEMDRAW_DISABLED);
		if (boxstatus)box.AddItem("off", "Stop!");
	}
	box.ExitButton = true;
	box.Display(client, MENU_TIME_FOREVER);
	return Plugin_Handled;
}

public int boxcb(Menu box, MenuAction action, int client, int item)
{
	if (action == MenuAction_Select)
	{
		char info[32];
		box.GetItem(item, info, sizeof(info));
		if (StrEqual(info, "on"))
		{
			SetConVarInt(FindConVar("mp_teammates_are_enemies"), 1);
			for (int i = 0; i <= 9; i++)
			PrintToChatAll("%s %N started the box!", PREFIX, client);
			boxstatus = true;
		}
		if (StrEqual(info, "off"))
		{
			SetConVarInt(FindConVar("mp_teammates_are_enemies"), 0);
			for (int i = 0; i <= 9; i++)
			PrintToChatAll("%s %N stoped the box!", PREFIX, client);
		}
	}
}

public Action checkctcb(Handle Timer)
{
	if (CtChooser == -1 && VoteCtType == VoteCt_Off && (GetTeamClientCount(CS_TEAM_CT) + GetTeamClientCount(CS_TEAM_T)) >= 2)
	{
		CtChooser = -1;
		VoteCt();
		PrintToChatAll("%s There are no ct chooser, votect started.", PREFIX);
	}
	if ((GetTeamClientCount(CS_TEAM_CT) + GetTeamClientCount(CS_TEAM_T)) < 2)PrintToChatAll("%s Need 2+ players in the server for start play", PREFIX);
}

public Action cmd_ctchooser(int client, int args)
{
	if (CtChooser != -1)PrintToChat(client, "%s %N is the ct chooser.", PREFIX, CtChooser);
	else PrintToChat(client, "%s There are no ct chooser, wait for the votect.", PREFIX);
	
	return Plugin_Handled;
}

public Action Event_PlayerSpawn(Event event, const char[] name, bool dB)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	
	if (viptimer[client] != INVALID_HANDLE)
	{
		KillTimer(viptimer[client]);
		viptimer[client] = INVALID_HANDLE;
		SetEntityRenderMode(client, RENDER_NORMAL);
		SetEntityRenderFx(client, RENDERFX_NONE);
		SetEntityRenderColor(client, 255, 255, 255, 255);
	}
	
	if (VoteCtType == VoteCt_GodRound)SetEntProp(client, Prop_Data, "m_takedamage", 0, 1);
}

public void OnMapStart()
{
	SetConVarInt(FindConVar("sv_airaccelerate"), 999999999);
	VoteCtType = VoteCt_Off;
	CtChooser = -1;
	for (int i = 0; i < sizeof(spawnpos); i++)
	{
		spawnpos[i][0] = 0.0;
		spawnpos[i][1] = 0.0;
		spawnpos[i][2] = 0.0;
	}
	GetCurrentMap(VoteCt_Currectmap, sizeof(VoteCt_Currectmap));
}

public Action Event_RoundEnd(Event event, const char[] name, bool dB)
{
	SetConVarInt(FindConVar("mp_teammates_are_enemies"), 0);
	boxstatus = false;
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && viptimer[i] != INVALID_HANDLE)
		{
			KillTimer(viptimer[i]);
			viptimer[i] = INVALID_HANDLE;
			SetEntityRenderMode(i, RENDER_NORMAL);
			SetEntityRenderFx(i, RENDERFX_NONE);
			SetEntityRenderColor(i, 255, 255, 255, 255);
		}
	}
}

public Action cmd_vip(int client, int args)
{
	if (args != 1)
	{
		PrintToChat(client, "%s Usage: sm_vip <target>.", PREFIX);
		return Plugin_Handled;
	}
	if (GetClientTeam(client) != CS_TEAM_CT && !CheckCommandAccess(client, "sm_admin", ADMFLAG_BAN))
	{
		PrintToChat(client, "%s This command resserved for ct`s.", PREFIX);
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target = FindTarget(client, arg1, false, false);
	if (!target)
	{
		PrintToChat(client, "%s Invalid Target.", PREFIX);
		return Plugin_Handled;
	}
	if (GetClientTeam(target) != CS_TEAM_T)
	{
		PrintToChat(client, "%s You can only give vip to t`s players.", PREFIX);
		return Plugin_Handled;
	}
	if (!IsPlayerAlive(target))
	{
		PrintToChat(client, "%s You can only give vip to alive players.", PREFIX);
		return Plugin_Handled;
	}
	if (viptimer[target] != INVALID_HANDLE)
	{
		KillTimer(viptimer[target]);
		viptimer[target] = INVALID_HANDLE;
		SetEntityRenderMode(target, RENDER_NORMAL);
		SetEntityRenderFx(target, RENDERFX_NONE);
		SetEntityRenderColor(target, 255, 255, 255, 255);
		PrintToChatAll("%s %N are no longer vip (by %N)", PREFIX, target, client);
		return Plugin_Handled;
	}
	viptimer[target] = CreateTimer(0.3, VipTimercb, target, TIMER_REPEAT);
	SetEntityRenderMode(target, RENDER_GLOW);
	SetEntityRenderFx(target, RENDERFX_GLOWSHELL);
	PrintToChatAll("%s %N get vip (by %N)", PREFIX, target, client);
	return Plugin_Handled;
}

public Action VipTimercb(Handle Timer, any client)
{
	float pos[3];
	int rgba[4];
	GetClientAbsOrigin(client, pos);
	pos[2] += 9;
	rgba[0] = GetRandomInt(10, 250);
	rgba[1] = GetRandomInt(10, 250);
	rgba[2] = GetRandomInt(10, 250);
	rgba[3] = 250;
	SetEntityRenderColor(client, rgba[0], rgba[1], rgba[2], rgba[3]);
	TE_SetupBeamRingPoint(pos, 5.0, 70.0, PrecacheModel("materials/sprites/laserbeam.vmt"), PrecacheModel("materials/sprites/glow01.vmt"), 0, 32, 0.45, 3.0, 0.0, rgba, 6, 0);
	TE_SendToAll();
}

public Action cmd_kickct(int client, int args)
{
	if (args != 1)
	{
		PrintToChat(client, "%s Usage: sm_kickct <target>.", PREFIX);
		return Plugin_Handled;
	}
	if (client != CtChooser)
	{
		PrintToChat(client, "%s You need to be the ct chooser to use this command.", PREFIX);
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target = FindTarget(client, arg1, false, false);
	if (!target)
	{
		PrintToChat(client, "%s Invalid Target.", PREFIX);
		return Plugin_Handled;
	}
	if (GetClientTeam(target) != CS_TEAM_CT)
	{
		PrintToChat(client, "%s You can only kick ct`s players.", PREFIX);
		return Plugin_Handled;
	}
	if (target == client)
	{
		PrintToChat(client, "%s You can`t kick yourself.", PREFIX);
		return Plugin_Handled;
	}
	CS_SwitchTeam(target, CS_TEAM_T);
	if (IsPlayerAlive(target))ForcePlayerSuicide(target);
	if (FindValueInArray(ctalgorithm, target) != -1)RemoveFromArray(ctalgorithm, FindValueInArray(ctalgorithm, target));
	PrintToChatAll("%s %N was kicked from ct`s team by %N.", PREFIX, target, client);
	return Plugin_Handled;
}

public Action Command_JoinTeam(int client, const char[] command, int args)
{
	if (!IsValidClient(client))return Plugin_Continue;
	
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int teamnum = StringToInt(arg1);
	if (!teamnum)FakeClientCommand(client, "jointeam 2");
	if (teamnum != 2)
	{
		PrintToChat(client, "%s You cannot change your team.", PREFIX);
		return Plugin_Handled;
	}
	if (!CheckCommandAccess(client, "sm_admin", ADMFLAG_BAN) && !BaseComm_IsClientMuted(client))
	{
		SetClientListeningFlags(client, VOICE_MUTED);
		PrintToChat(client, "%s You have been muted to this round.", PREFIX);
	}
	if (teamnum == 2 && FindValueInArray(ctalgorithm, client) != -1)RemoveFromArray(ctalgorithm, FindValueInArray(ctalgorithm, client));
	return Plugin_Continue;
}

public Action cmd_ctlist(int client, int args)
{
	if (client == CtChooser)CtList(client);
	else PrintToChat(client, "%s This command resserved for ct chooser.", PREFIX);
	return Plugin_Handled;
}

public void OnClientDisconnect(int client)
{
	SDKHook(client, SDKHook_OnTakeDamage, VoteCt_TakeDamage);
	if (viptimer[client] != INVALID_HANDLE)
	{
		KillTimer(viptimer[client]);
		viptimer[client] = INVALID_HANDLE;
		SetEntityRenderMode(client, RENDER_NORMAL);
		SetEntityRenderFx(client, RENDERFX_NONE);
		SetEntityRenderColor(client, 255, 255, 255, 255);
	}
}

public Action VoteCt_TakeDamage(int victim, int &attacker, int &inflictor, float &damage, int &damagetype, int &weapon, float damageForce[3], float damagePosition[3])
{
}

public Action Event_PlayerDeath(Event event, const char[] name, bool dB)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	if (!CheckCommandAccess(client, "sm_admin", ADMFLAG_BAN) && !BaseComm_IsClientMuted(client))
	{
		SetClientListeningFlags(client, VOICE_MUTED);
		PrintToChat(client, "%s You have been muted to this round.", PREFIX);
	}
	int alivecount = 0;
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam(i) == CS_TEAM_T)++alivecount;
	if (alivecount < 3 && boxstatus)
	{
		SetConVarInt(FindConVar("mp_teammates_are_enemies"), 0);
		PrintToChatAll("%s Only 2 players alive box stop.", PREFIX);
	}
	if (viptimer[client] != INVALID_HANDLE)
	{
		KillTimer(viptimer[client]);
		viptimer[client] = INVALID_HANDLE;
		SetEntityRenderMode(client, RENDER_NORMAL);
		SetEntityRenderFx(client, RENDERFX_NONE);
		SetEntityRenderColor(client, 255, 255, 255, 255);
		PrintToChat(client, "%s You are no longer vip", PREFIX);
	}
}

public Action Event_RoundStart(Event event, const char[] name, bool dB)
{
	if ((GetTeamScore(CS_TEAM_CT) + GetTeamScore(CS_TEAM_T)) == 5)
	{
		PrintToChatAll("%s CounterTerrorist`s team enterd 5 rounds, votect started", PREFIX);
		VoteCt();
	} else PrintToChatAll("%s Day %d started", PREFIX, ((GetTeamScore(CS_TEAM_CT) + GetTeamScore(CS_TEAM_T)) + 1));
	boxstatus = false;
	VoteCt_CellsOpen = false;
	SetConVarInt(FindConVar("sv_full_alltalk"), 1);
	SetConVarInt(FindConVar("mp_autoteambalance"), 0);
	spawncounts = 0;
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_T && IsPlayerAlive(i))
		{
			GetClientAbsOrigin(i, spawnpos[spawncounts]);
			++spawncounts;
		}
	}
	
	if (GetTeamClientCount(CS_TEAM_CT) > ((GetTeamClientCount(CS_TEAM_T)) - 1) / ctsvsguardscount.IntValue && GetArraySize(ctalgorithm) > 0)
	{
		int target = GetArrayCell(ctalgorithm, (GetArraySize(ctalgorithm) - 1));
		CS_SwitchTeam(target, CS_TEAM_T);
		CreateTimer(0.5, fixtimer, target);
		PrintToChatAll("%s %N was automatically swap to t team, ct team full!", PREFIX, target);
		RemoveFromArray(ctalgorithm, (GetArraySize(ctalgorithm) - 1));
	}
	PrintToChatAll("%s All terrorist has been muted to %d sec.", PREFIX, startmutetime.IntValue);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !CheckCommandAccess(i, "sm_admin", ADMFLAG_BAN) && !BaseComm_IsClientMuted(i))
		{
			if (GetClientTeam(i) == CS_TEAM_T)SetClientListeningFlags(i, VOICE_MUTED);
			if (GetClientTeam(i) == CS_TEAM_CT)SetClientListeningFlags(i, VOICE_NORMAL);
		}
	}
	CreateTimer(startmutetime.FloatValue, unmuteall, INVALID_HANDLE);
}

public Action fixtimer(Handle Timer, any target)
{
	CS_RespawnPlayer(target);
}

public Action unmuteall(Handle Timer)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !CheckCommandAccess(i, "sm_admin", ADMFLAG_BAN) && !BaseComm_IsClientMuted(i))SetClientListeningFlags(i, VOICE_NORMAL);
	}
}

public Action Command_Say(int client, const char[] command, int args)
{
	if (VoteCtType == VoteCt_Math)
	{
		char arg1[32];
		GetCmdArg(1, arg1, sizeof(arg1));
		int number = StringToInt(arg1);
		if (ctbanned(client))
		{
			PrintToChat(client, "%s You cannot be ct chooser when you have freekill.", PREFIX);
			return Plugin_Handled;
		}
		if (client == CtChooser)
		{
			PrintToChat(client, "%s Your cannot be chooser again.", PREFIX);
			return Plugin_Handled;
		}
		if (number != MathNumber)
		{
			PrintToChat(client, "%s Wrong Answer.", PREFIX);
			return Plugin_Handled;
		}
		if (mathquestion != INVALID_HANDLE)
		{
			KillTimer(mathquestion);
			mathquestion = INVALID_HANDLE;
		}
		VoteCtType = VoteCt_GodRound;
		CtChooser = client;
		for (int i = 1; i <= MaxClients; i++)
		if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
		SetConVarInt(FindConVar("mp_restartgame"), 1);
		CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
		PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
		CreateTimer(2.0, mathquestionwinmdisplay, INVALID_HANDLE);
		CS_SwitchTeam(CtChooser, CS_TEAM_CT);
		CS_RespawnPlayer(CtChooser);
		CtList(CtChooser);
	}
	if (VoteCtType == VoteCt_FastWrite)
	{
		char arg1[32];
		GetCmdArg(1, arg1, sizeof(arg1));
		if (ctbanned(client))
		{
			PrintToChat(client, "%s You cannot be ct chooser when you have freekill.", PREFIX);
			return Plugin_Handled;
		}
		if (client == CtChooser)
		{
			PrintToChat(client, "%s Your cannot be chooser again.", PREFIX);
			return Plugin_Handled;
		}
		if (!StrEqual(arg1, fastwritestring))
		{
			PrintToChat(client, "%s Wrong type.", PREFIX);
			return Plugin_Handled;
		}
		if (fastwrite != INVALID_HANDLE)
		{
			KillTimer(fastwrite);
			fastwrite = INVALID_HANDLE;
		}
		VoteCtType = VoteCt_GodRound;
		CtChooser = client;
		for (int i = 1; i <= MaxClients; i++)
		if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
		SetConVarInt(FindConVar("mp_restartgame"), 1);
		CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
		PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
		CreateTimer(2.0, fastwritewinmdisplay, INVALID_HANDLE);
		CS_SwitchTeam(CtChooser, CS_TEAM_CT);
		CS_RespawnPlayer(CtChooser);
		CtList(CtChooser);
	}
	if (VoteCtType == VoteCt_RandomNumber)
	{
		char arg1[32];
		GetCmdArg(1, arg1, sizeof(arg1));
		int number = StringToInt(arg1);
		if (ctbanned(client))
		{
			PrintToChat(client, "%s You cannot be ct chooser when you have freekill.", PREFIX);
			return Plugin_Handled;
		}
		if (FindValueInArray(randomnumber_client, client) != -1)
		{
			PrintToChat(client, "%s You already choose number.", PREFIX);
			return Plugin_Handled;
		}
		if (number < 1 || number > 350)
		{
			PrintToChat(client, "%s Your number need be 1 - 350.", PREFIX);
			return Plugin_Handled;
		}
		if (client == CtChooser)
		{
			PrintToChat(client, "%s Your cannot be chooser again.", PREFIX);
			return Plugin_Handled;
		}
		
		PushArrayCell(randomnumber_number, number);
		PushArrayCell(randomnumber_client, client);
		
		PrintToChat(client, "%s Your number has been submitted.", PREFIX);
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public Action mathquestionwinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "%N confirm the math question, and won", CtChooser);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.35, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

public Action fastwritewinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "%N confirm the fast write, and won", CtChooser);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.35, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

public Action godrundcb(Handle Timer)
{
	if (VoteCtType == VoteCt_GodRound)
	{
		for (int i = 1; i <= MaxClients; i++)
		if (IsValidClient(i))SetEntProp(i, Prop_Data, "m_takedamage", 2, 1);
		SetConVarInt(FindConVar("mp_restartgame"), 1);
		PrintToChatAll("%s God round end", PREFIX);
		VoteCtType = VoteCt_Off;
	}
}

public Action cmd_votect(int client, int args)
{
	if (VoteCtType != VoteCt_Off)
	{
		PrintToChat(client, "%s Votect already in progress.", PREFIX);
		return Plugin_Handled;
	}
	if (CtChooser == -1)
	{
		PrintToChat(client, "%s You need wait for the autovotect.", PREFIX);
		return Plugin_Handled;
	}
	VoteCt();
	PrintToChatAll("%s %N start the votect.", PREFIX, client);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i))
		{
			if (GetClientTeam(i) == CS_TEAM_CT && !CheckCommandAccess(i, "sm_admin", ADMFLAG_BAN))CS_SwitchTeam(i, CS_TEAM_T);
			
			if (i == client)CS_SwitchTeam(i, CS_TEAM_CT);
		}
	}
	return Plugin_Handled;
}

public void VoteCt()
{
	VoteCtType = VoteCt_Wait;
	ClearArray(ctalgorithm);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i))
		{
			CS_RespawnPlayer(i);
			SetEntProp(i, Prop_Data, "m_takedamage", 0, 1);
		}
	}
	
	char vtitle[64];
	Format(vtitle, sizeof(vtitle), "%s Choose Votect Method: ", MENUPREFIX);
	Menu votect = new Menu(VoteCtcb);
	votect.SetTitle(vtitle);
	
	static char menuitems[][][] = 
	{
		{ "randomnumber", "Random Number (1 - 350)\n" }, 
		{ "randomplayer", "Random Player\n" }, 
		{ "mostjump", "Most Jump\n" }, 
		{ "finddeagle", "Find The Real Deagle\n" }, 
		{ "fastwrite", "Fast Write\n" }, 
		{ "math", "Math Question\n" }, 
		{ "combo", "Combo\n" }
	};
	
	bool isadded[sizeof(menuitems)] = false;
	int randomitem = 0;
	int count = 0;
	while (!isadded[0] || !isadded[1] || !isadded[2] || !isadded[3] || !isadded[4] || !isadded[5] || !isadded[6])
	{
		if (count == 5)break;
		randomitem = GetRandomInt(0, (sizeof(menuitems) - 1));
		if (isadded[randomitem])continue;
		votect.AddItem(menuitems[randomitem][0], menuitems[randomitem][1]);
		isadded[randomitem] = true;
		++count;
	}
	votect.AddItem("nothing", "Dont Change Ct");
	/*votect.AddItem("randomnumber", "Random Number (1 - 350)");
	votect.AddItem("randomplayer", "Random Player");
	votect.AddItem("mostjump", "Most Jump");
	votect.AddItem("finddeagle", "Find The Real Deagle");
	votect.AddItem("fastwrite", "Fast Write");
	votect.AddItem("math", "Math Question");
	votect.AddItem("combo", "Combo");*/
	votect.ExitButton = false;
	votect.DisplayVoteToAll((votecttime.IntValue));
	//Questions
	//Most Drops
}

public int VoteCtcb(Menu votect, MenuAction action, int client, int item)
{
	if (action == MenuAction_VoteEnd)
	{
		char info[32];
		votect.GetItem(client, info, sizeof(info));
		if (StrEqual(info, "nothing"))
		{
			VoteCtType = VoteCt_Off;
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.25, 0.2, randomnumbertime.FloatValue, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "The CounterTerrorist`s Have Anther 5 Rounds");
				}
			}
			for (int i = 1; i <= MaxClients; i++)
			if (IsValidClient(i))SetEntProp(i, Prop_Data, "m_takedamage", 2, 1);
			SetConVarInt(FindConVar("mp_restartgame"), 1);
		}
		if (StrEqual(info, "randomnumber"))
		{
			VoteCtType = VoteCt_RandomNumber;
			
			ClearArray(randomnumber_client);
			ClearArray(randomnumber_number);
			
			RandomNumber = GetRandomInt(1, 350);
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.25, 0.2, randomnumbertime.FloatValue, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Random Number Started! Choose Number From 1 - 350");
				}
			}
			
			CreateTimer(randomnumbertime.FloatValue, randomnumbercb, INVALID_HANDLE);
		}
		if (StrEqual(info, "randomplayer"))
		{
			VoteCtType = VoteCt_RandomPlayer;
			
			ClearArray(randomplayer);
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.28, 0.2, randomplayertime.FloatValue, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Random Player Started! Join To The Random List");
				}
			}
			
			for (int i = 1; i <= MaxClients; i++)
			if (IsValidClient(i) && i != CtChooser && !ctbanned(i))jointorandom(i);
			
			CreateTimer(randomplayertime.FloatValue, randomplayercb, INVALID_HANDLE);
		}
		if (StrEqual(info, "mostjump"))
		{
			VoteCtType = VoteCt_MostJump;
			
			for (int i = 1; i <= MaxClients; i++)if (IsValidClient(i) && jumpcount[i] > 0)jumpcount[i] = 0;
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.28, 0.2, mostjumptime.FloatValue, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Most Jump Started! Start Spam Your Space");
				}
			}
			
			CreateTimer(mostjumptime.FloatValue, mostjumpcb, INVALID_HANDLE);
		}
		if (StrEqual(info, "finddeagle"))
		{
			VoteCtType = VoteCt_FindDeagle;
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.28, 0.2, 2.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Find The Deagle Started! Start Search");
				}
			}
			
			for (int i = 0; i < spawncounts; i++)
			{
				realweapon = CreateEntityByName("weapon_deagle");
				DispatchSpawn(realweapon);
				TeleportEntity(realweapon, spawnpos[i], NULL_VECTOR, NULL_VECTOR);
			}
			
			findthedeagle = CreateTimer(finddeagle.FloatValue, finddeaglecb, INVALID_HANDLE);
		}
		if (StrEqual(info, "fastwrite"))
		{
			VoteCtType = VoteCt_FastWrite;
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.28, 0.2, 2.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Fast Write Started! Start Write");
				}
			}
			String_GetRandom(fastwritestring, sizeof(fastwritestring), 8, "123456789ABCDEFGHIJKLMNOKRSTUWXYZabcdefhigklmnopqrstuvwxyz");
			Format(fastwritestring, 32, "%s", fastwritestring);
			SendPanelToAll(MENUPREFIX, fastwritestring);
			fastwrite = CreateTimer(fastwritetime.FloatValue, fastwritecb, INVALID_HANDLE);
		}
		if (StrEqual(info, "math"))
		{
			VoteCtType = VoteCt_Math;
			
			char message[32];
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.28, 0.2, 2.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Math Question Started! Start Thinking");
				}
			}
			
			int num1 = GetRandomInt(-10, 10);
			int num2 = GetRandomInt(-10, 10);
			int mod = GetRandomInt(0, 3);
			if (mod == 0)
			{
				Format(message, sizeof(message), "%d + %d = ?", num1, num2);
				MathNumber = (num1 + num2);
			}
			if (mod == 1)
			{
				Format(message, sizeof(message), "%d - %d = ?", num1, num2);
				MathNumber = (num1 - num2);
			}
			if (mod == 2)
			{
				Format(message, sizeof(message), "%d * %d = ?", num1, num2);
				MathNumber = (num1 * num2);
			}
			if (mod == 3)
			{
				Format(message, sizeof(message), "%d / %d = ?", num1, num2);
				MathNumber = (num1 / num2);
			}
			SendPanelToAll(MENUPREFIX, message);
			
			mathquestion = CreateTimer(mathquestiontime.FloatValue, mathquestioncb, INVALID_HANDLE);
		}
		if (StrEqual(info, "combo"))
		{
			VoteCtType = VoteCt_Combo;
			
			int color1 = GetRandomInt(1, 255);
			int color2 = GetRandomInt(1, 255);
			int color3 = GetRandomInt(1, 255);
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && !IsClientSourceTV(i))
				{
					SetHudTextParams(0.38, 0.2, 2.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
					ShowHudText(i, 1, "Combo Started! Start Move");
				}
			}
			for (int i = 0; i <= MaxClients; i++)
			if (IsValidClient(i))PlayerPos[i] = 0;
			for (int i = 0; i < MOVES; i++)
			{
				ComboMoves[i] = Math_GetRandomInt(0, (MAXBUTTONS - 1));
				
				if (i != 0)
				{
					while (ComboMoves[i] == ComboMoves[i - 1])
					{
						ComboMoves[i] = Math_GetRandomInt(0, (MAXBUTTONS - 1));
					}
				}
			}
			comboendtime = CreateTimer(combotime.FloatValue, combocb, INVALID_HANDLE);
		}
	}
}

public Action combocb(Handle Timer)
{
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	VoteCtType = VoteCt_Off;
	VoteCt();
	PrintToChatAll("%s No one enter the combo, votect start again.", PREFIX);
}

public Action OnPlayerRunCmd(int client, int &buttons, int &impulse, float vel[3], float angles[3], int &weapon)
{
	if (VoteCtType == VoteCt_Combo && IsValidClient(client) && !ctbanned(client) && client != CtChooser)
	{
		if (!(g_LastButtons[client] & buttons) && IsPressing(buttons))
		{
			if ((buttons & Buttons[ComboMoves[PlayerPos[client]]]))PlayerPos[client]++;
			
			else
			{
				PrintToChat(client, "%s Wrong Button!", PREFIX);
				PlayerPos[client] = 0;
			}
			g_LastButtons[client] = buttons;
			
			if (PlayerPos[client] >= MOVES)
			{
				if (combotimer != INVALID_HANDLE)
				{
					KillTimer(combotimer);
					combotimer = INVALID_HANDLE;
				}
				if (comboendtime != INVALID_HANDLE)
				{
					KillTimer(comboendtime);
					comboendtime = INVALID_HANDLE;
				}
				VoteCtType = VoteCt_GodRound;
				CtChooser = client;
				for (int i = 1; i <= MaxClients; i++)
				if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
				SetConVarInt(FindConVar("mp_restartgame"), 1);
				CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
				PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
				CreateTimer(2.0, combowinmdisplay, INVALID_HANDLE);
				CS_SwitchTeam(CtChooser, CS_TEAM_CT);
				CS_RespawnPlayer(CtChooser);
				CtList(CtChooser);
			}
		}
		PrintHintText(client, "<u>%s</u> \n--><b><font color='#FF6666'>%s</font></b> \n%s", (PlayerPos[client] == 0) ? "Begin:" : "Continue:", sButtons[ComboMoves[PlayerPos[client]]], (PlayerPos[client] == (MOVES - 1)) ? "Done!" : sButtons[ComboMoves[PlayerPos[client] + 1]]);
	}
}

public Action combowinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "%N enter all the types, and won", CtChooser, realweapon);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.35, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

public bool IsPressing(buttons)
{
	for (int i = 0; i < MAX_BUTTONS; i++)
	{
		if (buttons & (1 << i))
		{
			return true;
		}
	}
	
	return false;
}


public Action mathquestioncb(Handle Timer)
{
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	VoteCtType = VoteCt_Off;
	VoteCt();
	PrintToChatAll("%s No one find the math answer, votect start again.", PREFIX);
}

public void SendPanelToAll(char[] title, char[] message)
{
	ReplaceString(message, 192, "\\n", "\n");
	Handle mSayPanel = CreatePanel();
	SetPanelTitle(mSayPanel, title);
	DrawPanelItem(mSayPanel, "", ITEMDRAW_SPACER);
	DrawPanelText(mSayPanel, message);
	DrawPanelItem(mSayPanel, "", ITEMDRAW_SPACER);
	
	SetPanelCurrentKey(mSayPanel, 3);
	DrawPanelItem(mSayPanel, "Exit", ITEMDRAW_CONTROL);
	
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i))
		{
			SendPanelToClient(mSayPanel, i, Handler_DoNothing, 30);
		}
	}
	
	delete mSayPanel;
}

public Handler_DoNothing(Menu menu, MenuAction action, int param1, int param2)
{
	/* Do nothing */
}

public Action fastwritecb(Handle Timer)
{
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	VoteCtType = VoteCt_Off;
	VoteCt();
	PrintToChatAll("%s No one copy the fastwrite message, votect start again.", PREFIX);
}

public Action onweaponup(int client, int entity)
{
	if (VoteCtType == VoteCt_FindDeagle)
	{
		if (realweapon == entity)
		{
			findthedeaglewin(client);
			return Plugin_Continue;
		} else return Plugin_Handled;
	}
	return Plugin_Continue;
}

public void findthedeaglewin(int client)
{
	if (findthedeagle != INVALID_HANDLE)
	{
		KillTimer(findthedeagle);
		findthedeagle = INVALID_HANDLE;
	}
	VoteCtType = VoteCt_GodRound;
	CtChooser = client;
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
	PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
	CreateTimer(2.0, finddeaglewinmdisplay, INVALID_HANDLE);
	CS_SwitchTeam(CtChooser, CS_TEAM_CT);
	CS_RespawnPlayer(CtChooser);
	CtList(CtChooser);
}

public Action finddeaglewinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "%N find the deagle (%d), and won", CtChooser, realweapon);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.35, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

public void OnClientPutInServer(int client)
{
	SDKHook(client, SDKHook_WeaponEquip, onweaponup);
}

public Action finddeaglecb(Handle Timer)
{
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	VoteCtType = VoteCt_Off;
	VoteCt();
	PrintToChatAll("%s No one find the deagle, votect start again.", PREFIX);
}

public Action mostjumpcb(Handle Timer)
{
	int count = 0;
	lastnum = 0;
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && jumpcount[i] > 0)
		{
			if (jumpcount[i] > lastnum)
			{
				CtChooser = i;
				lastnum = jumpcount[i];
			}
			++count;
		}
	}
	if (count == 0)
	{
		VoteCtType = VoteCt_Off;
		VoteCt();
		PrintToChatAll("%s No one jump, votect start again.", PREFIX);
		return;
	}
	winnum = lastnum;
	VoteCtType = VoteCt_GodRound;
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
	PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
	CreateTimer(2.0, mostjumpwinmdisplay, INVALID_HANDLE);
	CS_SwitchTeam(CtChooser, CS_TEAM_CT);
	CS_RespawnPlayer(CtChooser);
	CtList(CtChooser);
}

public Action mostjumpwinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "%N jump %d times, and won", CtChooser, winnum);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.35, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

public Action Event_Jump(Event event, const char[] name, bool dB)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	if (VoteCtType == VoteCt_MostJump && client != CtChooser && !ctbanned(client))++jumpcount[client];
	return Plugin_Continue;
}

public Action randomplayercb(Handle Timer)
{
	if (GetArraySize(randomplayer) < 1)
	{
		ClearArray(randomplayer);
		VoteCtType = VoteCt_Off;
		
		VoteCt();
		PrintToChatAll("%s No one join to the random player list, votect start again.", PREFIX);
		return;
	}
	
	CtChooser = GetArrayCell(randomplayer, GetRandomInt(0, (GetArraySize(randomplayer) - 1)));
	
	ClearArray(randomplayer);
	VoteCtType = VoteCt_GodRound;
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
	PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
	CreateTimer(2.0, randomplayerwinmdisplay, INVALID_HANDLE);
	CS_SwitchTeam(CtChooser, CS_TEAM_CT);
	CS_RespawnPlayer(CtChooser);
	CtList(CtChooser);
	
}

public Action randomplayerwinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "%N is the random player", CtChooser);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.35, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

public void jointorandom(int client)
{
	char title[32];
	Menu jtrandom = new Menu(jtrandomcb);
	Format(title, sizeof(title), "%s You want be ct chooser?", MENUPREFIX);
	jtrandom.SetTitle(title);
	jtrandom.AddItem("yes", "Yes");
	jtrandom.AddItem("no", "No");
	jtrandom.ExitButton = false;
	jtrandom.Display(client, (randomplayertime.IntValue - 1));
}

public int jtrandomcb(Menu jtrandom, MenuAction action, int client, int item)
{
	if (action == MenuAction_Select)
	{
		char info[32];
		jtrandom.GetItem(item, info, sizeof(info));
		if (StrEqual(info, "yes"))PushArrayCell(randomplayer, client);
	}
}

public Action randomnumbercb(Handle Timer)
{
	VoteCtType = VoteCt_Wait;
	lastnum = 350;
	if (GetArraySize(randomnumber_client) < 1)
	{
		ClearArray(randomnumber_client);
		ClearArray(randomnumber_number);
		VoteCtType = VoteCt_Off;
		VoteCt();
		PrintToChatAll("%s No one entered number, votect start again.", PREFIX);
		return;
	}
	for (int i = 0; i < GetArraySize(randomnumber_client); i++)
	{
		int client = GetArrayCell(randomnumber_client, i);
		int number = GetArrayCell(randomnumber_number, i);
		int dif = (RandomNumber - number);
		if (dif < 0)dif = -dif;
		if (dif < lastnum)
		{
			lastnum = dif;
			CtChooser = client;
			winnum = number;
		}
	}
	ClearArray(randomnumber_client);
	ClearArray(randomnumber_number);
	VoteCtType = VoteCt_GodRound;
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_CT && i != CtChooser)CS_SwitchTeam(i, CS_TEAM_T);
	SetConVarInt(FindConVar("mp_restartgame"), 1);
	CreateTimer(godroundtime.FloatValue, godrundcb, INVALID_HANDLE);
	PrintToChatAll("%s God round for %d sec started.", PREFIX, godroundtime.IntValue);
	CreateTimer(2.0, randomnumberwinmdisplay, INVALID_HANDLE);
	CS_SwitchTeam(CtChooser, CS_TEAM_CT);
	CS_RespawnPlayer(CtChooser);
	CtList(CtChooser);
}

public void CtList(int client)
{
	if (GetTeamClientCount(CS_TEAM_CT) < ((GetTeamClientCount(CS_TEAM_T)) - 1) / ctsvsguardscount.IntValue)
	{
		char title[64], name[MAX_NAME_LENGTH];
		Menu ctlist = new Menu(CtListcb);
		Format(title, sizeof(title), "%s You need choose more %d ct`s", MENUPREFIX, ((GetTeamClientCount(CS_TEAM_T)) - 1) / ctsvsguardscount.IntValue);
		ctlist.SetTitle(title);
		ctlist.AddItem("all", "Choose all players");
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_T && !ctbanned(i))
			{
				Format(name, sizeof(name), "%N", i);
				ctlist.AddItem(name, name);
			}
		}
		ctlist.ExitButton = true;
		ctlist.Display(client, MENU_TIME_FOREVER);
	} else PrintToChat(client, "%s Ct`s team full!", PREFIX);
}

public int CtListcb(Menu ctlist, MenuAction action, int client, int item)
{
	if (action == MenuAction_Select)
	{
		char info[MAX_NAME_LENGTH];
		ctlist.GetItem(item, info, sizeof(info));
		if (StrEqual(info, "all"))
		{
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && GetClientTeam(i) == CS_TEAM_T && !ctbanned(i))CtAsk(i);
			}
		} else CtAsk(FindTarget(client, info, true, false));
	}
}

public void CtAsk(int client)
{
	char title[64];
	Menu askmenu = new Menu(askmenucb);
	Format(title, sizeof(title), "%s You invited to ct`s team by %N", MENUPREFIX, CtChooser);
	askmenu.SetTitle(title);
	askmenu.AddItem("accept", "Accept");
	askmenu.AddItem("decline", "Decline");
	askmenu.ExitButton = true;
	askmenu.Display(client, (ctanswertime.IntValue));
}

public int askmenucb(Menu askmenu, MenuAction action, int client, int item)
{
	if (action == MenuAction_Select)
	{
		char info[32];
		askmenu.GetItem(item, info, sizeof(info));
		if (StrEqual(info, "accept"))
		{
			SwapToCt(client);
			PrintToChatAll("%s %N accept the ct`s invite (by %N).", PREFIX, client, CtChooser);
		}
		if (StrEqual(info, "decline"))
		{
			CtList(CtChooser);
			PrintToChatAll("%s %N Has decline the invite (by %N).", PREFIX, client, CtChooser);
		}
	}
}

public Action randomnumberwinmdisplay(Handle Timer)
{
	char winmessage[64];
	Format(winmessage, sizeof(winmessage), "The random number is %d, %N choose %d and won", RandomNumber, CtChooser, winnum);
	int color1 = GetRandomInt(1, 255);
	int color2 = GetRandomInt(1, 255);
	int color3 = GetRandomInt(1, 255);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && !IsClientSourceTV(i))
		{
			SetHudTextParams(0.25, 0.2, 5.0, color1, color2, color3, 255, 2, 0.0, 0.1, 0.0);
			ShowHudText(i, 1, winmessage);
		}
	}
}

stock int SwapToCt(int client)
{
	if (GetTeamClientCount(CS_TEAM_CT) < ((GetTeamClientCount(CS_TEAM_T)) - 1) / ctsvsguardscount.IntValue)
	{
		CS_SwitchTeam(client, CS_TEAM_CT);
		if (IsPlayerAlive(client))ForcePlayerSuicide(client);
		
		PushArrayCell(ctalgorithm, client);
	} else PrintToChat(client, "%s Ct`s team full!", PREFIX);
}

stock bool IsValidClient(int client)
{
	if (client >= 1 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client))
	{
		return true;
	}
	
	return false;
}

stock bool ctbanned(int client)
{
	char sBanned[8];
	GetClientCookie(client, ctbanconnect, sBanned, 8);
	int Banned = StringToInt(sBanned);
	if (Banned)return true;
	else return false;
}

stock bool CanTarget(int client, int target)
{
	char authtarget[32];
	GetClientAuthId(target, AuthId_Steam2, authtarget, sizeof(authtarget));
	AdminId source_aid = GetUserAdmin(client), target_aid;
	if ((target_aid = FindAdminByIdentity(AUTHMETHOD_STEAM, authtarget)) == INVALID_ADMIN_ID || CanAdminTarget(source_aid, target_aid))return true;
	else return false;
} 